REBOL [
	Title: "Installer Utilities"
	Rights: "Copyright REBOL Technologies 1997-2005. All rights reserved."
	; You are free to use, modify, and distribute this software with any
	; REBOL Technologies products as long as the above header, copyright,
	; and this comment remain intact. This software is provided "as is"
	; and without warranties of any kind. In no event shall the owners or
	; contributors be liable for any damages of any kind, even if advised
	; of the possibility of such damage. See license for more information.

	; Please help us to improve this software by contributing changes and
	; fixes via http://www.rebol.com/feedback.html - Thanks!
]

winos?: system/version/4 = 3

ms-base: "Software\Microsoft\Windows\CurrentVersion"
ms-uninstall: join ms-base "\Uninstall\"
ms-folders: join ms-base "\Explorer\Shell Folders"

reg-base: func [maker name] [rejoin ["Software\" maker #"\" name #"\"]]

delete-regs: func [
	; Recursively delete registry keys.
	path ; registry path
	/hklm
	/local keys
][
	keys: either hklm [list-reg/hklm path] [list-reg path]
	if none? keys [exit]
	foreach key keys [
		delete-regs rejoin [path #"\" key]
	]
	either hklm [delete-reg/hklm path] [delete-reg path]
]

delete-reg-hkcr: func [
	; Recursively delete registry keys.
	path ; registry path
	/local keys
][
	keys: list-reg/hkcr path
	if none? keys [exit]
	foreach key keys [
		delete-reg-hkcr rejoin [path #"\" key]
	]
	;print path
	delete-reg/hkcr path
]

delete-link: func [file] [
	; Delete a link file.
	file: join to-rebol-file file ".lnk"
	if exists? file [attempt [delete file]]
]
